<template>
  <div>
    <h3>{{ kex }}</h3>
    <p>
      <button
        class="btn btn-secondary"
        type="button"
        @click.prevent="$emit('refreshRequested', kex)"
      >
        <i class="fas fa-sync"></i> Refresh tables in
        <strong>{{ details.kex }}</strong>
      </button>
    </p>
    <p>
      Kex id: <code>{{ details.kex }}</code
      ><br />
      Project/database: <code>{{ details.project }}</code>
    </p>
    <p>
      <dropdown-menu title="Actions" icon="fas fa-rocket" color="primary">
        <a
          href="#"
          class="btn btn-danger mt-1"
          @click.prevent="deleteKexPrompt = true"
          ><i class="fas fa-trash"></i> Delete</a
        >
      </dropdown-menu>
    </p>
    <api-data
      :endpoint="`/storage/kex/${kex}`"
      ref="tablesLister"
      v-model="details"
    />
    <transition name="fade">
      <progress-spinner v-if="disabled" />
    </transition>
    <modal-dialog
      v-if="deleteKexPrompt"
      confirm="Delete"
      title="Delete kex"
      static
      @close="deleteKexEvent"
      >Do you really wish to delete kex <code>{{ kex }}</code
      >? This is irreversible. That means <strong>permanent</strong>. You cannot
      take this back.
    </modal-dialog>
  </div>
</template>

<script>
export default {
  name: "KexDetails",
  inject: ["refreshStorage", "deleteKex"],
  emits: ["refreshRequested"],
  methods: {
    deleteKexEvent({ value }) {
      this.deleteKexPrompt = false;
      if (value) {
        this.deleteKex(this.kex);
      }
    },
  },
  data() {
    return {
      details: {},
      disabled: false,
      deleteKexPrompt: false,
    };
  },
  props: {
    kex: String,
  },
};
</script>

<style></style>
